<?php

// Lire la requête POST émanant de Paypal
// et y ajouter la commande _notify-validate
$req = 'cmd=_notify-validate';

foreach ($_POST as $key => $value) {
	$value = urlencode(stripslashes($value));
	$req .= "&$key=$value";
}

// reposter à Paypal pour validation
// Pour cela, on constitue une requête HTTP
// que l'on écrit dans un socket
$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
$fp = fsockopen ('ssl://www.sandbox.paypal.com', 443, $errno, $errstr, 30);

// Conserver les variables reçues selon les besoins
$item_name = $_POST['item_name'];
$item_number = $_POST['item_number'];
$payment_status = $_POST['payment_status'];
$payment_amount = $_POST['mc_gross'];
$payment_currency = $_POST['mc_currency'];
$txn_id = $_POST['txn_id'];
$receiver_email = $_POST['receiver_email'];
$payer_email = $_POST['payer_email'];
$id_user = $_POST['custom'];

// Ouvrir un fichier de "log"
$log = fopen("log-ipn.txt", "a+");

if (!$fp) {
	fputs($log, "Erreur HTTP; l'IPN sera traitee une prochaine fois\n");
}
else {
	// écrire la requête POST dans le socket
	fputs ($fp, $header . $req);
	// puis lire la réponse du serveur dans le socket
	while (!feof($fp)) {
		$res = fgets ($fp, 1024);
		if (strcmp ($res, "VERIFIED") == 0) {
			// Vérifier que la transaction est terminée
			if($payment_status == 'Completed') {
				// Verifier que la transaction n'a pas déjà été traitée
				$msg = "Verification transaction: " . $txn_id . "\n";
				fputs($log, $msg);
				// Vérifier que le compte crédité est le bon
				$msg = "Verification compte crédité:" . $receiver_email . "\n";
				fputs($log, $msg);
				// Vérifier montant et devise
				$msg = "Vérification montant:" . $payment_amount . " " . $payment_currency . "\n";
				fputs($log, $msg);
				// enregistrer transaction
				fputs($log, "Transaction enregistree en base de donnees\n");
			}
			else {
				$msg = "Transaction: " . $txn_id . "-> " . $payment_status . "\n";
				fputs($log, $msg);
			}
	}
	else if (strcmp ($res, "INVALID") == 0) {
		$msg = "La transaction " . $txn_id . " a ete invalidee par Paypal\n"; 
		fputs($log, $msg);
		$msg = "Il faut en avertir l'utilisateur " . $id_user . " :" . $payer_email . "\n";
		fputs($log, $msg);
	}
}
fclose ($fp);
fclose($log);
}
?>



